LPARAMETERS m.lcType,m.lcFile


*!*   SET PATH TO "G:\Clients\xfrx\xfrx-dev\XFRX\"
*!*   SET DEFA TO "G:\Clients\xfrx\xfrx-dev\XFRX\"

CLEAR
close all

LOCAL lcAlias,lcOUT, lcPath, m.XX, m.lcXFRXFolder, m.lii, m.loXFRX, m.lcVers

m.lcXFRXFolder=LOCFILE("xfrx.prg","prg;fxp;app","Locate XFRX")
IF EMPTY(m.lcXFRXFolder)
   RETURN
ENDIF
m.lii=RAT("\",m.lcXFRXFolder)
m.lcXFRXFolder=LEFT(m.lcXFRXFolder,m.lii)


SET PATH TO (m.lcXFRXFolder) ADDITIVE
SET DEFA TO (m.lcXFRXFolder)

m.loXFRX=EVALUATE([xfrx("XFRX#INIT")])
m.lcVers=m.loXFRX.getVersion()
RELEASE m.loXFRX
m.lii=AT(".",m.lcVers,2)
IF EVALUATE(LEFT(m.lcVers, m.lii-1))*10<171
   ?"XFRX minimal version must be XFRX 17.1"
   RETURN
ENDIF


SET PROCEDURE TO xfrx.prg ADDITIVE
SET LIBRARY TO xfrxlib.fll

lcOUT=PROGRAM()
lcPath=JUSTPATH(SYS(16))+"\"

m.XX=STRTRAN(FILETOSTR(m.lcFile),"%PATH%",lcPath)

_Screen.AddObject("R1","shape")
_Screen.R1.Move(0,0,740,110)
_Screen.R1.Visible=.T.

m.loSH=CREATEOBJECT("_SCREENHOST")

loParser=CREATEOBJECT("_PARSEMEMOFORMAT")
loParser.SetType(.NULL.,m.lcType) && <TF>, <BB>
loParser.SetHost(m.loSH,"XEVALUATE")

loParser.SetDefaultFormat("Arial",10,.F.,.F.,.F.,.F., 0, .NULL., 0/96*10000,0/96*10000,_Screen.R1.Width/96*10000,_Screen.R1.Height/96*10000,.T.,1250,"left") && stretch
loParser.Parse(m.XX)

loParser.RecalcToRectangle()

loParser.DrawToRectangle()
loParser.Clear()
_Screen.R1.Height=loParser.nNewHeight/10000*96

=INKEY(0)

*?loParser.nNewHeight/10000*96


CLOSE ALL
CLEAR ALL
RETURN

***********************************************************

DEFINE CLASS _SCREENHOST AS CUSTOM
   Name="_SCREENHOST"


   PROCEDURE XEVALUATE(m.lcAlias, m.lcDATA)
      *
      * _SCREENHOST::XEVALUATE
      *
      IF EMPTY(m.lcALIAS) 
         RETURN EVALUATE(m.lcDATA)
      ENDIF
      LOCAL m.luVAL, m.lcALIASX
      m.lcALIASX=ALIAS() 
      SELECT (m.lcAlias)
      m.luVAL=EVALUATE(m.lcDATA)
      SELECT (m.lcALIASX)
      RETURN m.luVAL
   ENDPROC

   PROCEDURE TF_AddText(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_AddText
      *
      LOCAL m.lcName 
      m.lcName="_"+LTRIM(STR(_Screen.ControlCount,11))+"_lbl"
      _Screen.AddObject(m.lcName,"label")
      m.loLabel=EVALUATE("_Screen."+m.lcName)
      WITH m.loLabel
      .Caption=m.loRam.XWORD
      .Left=m.loRam.NLEFT/10000*96
      .Top=m.loRam.NTOP/10000*96
      .Width=m.loRam.NWIDTH/10000*96+5
      .Height=m.loRam.NHEIGHTA/10000*96
      .FontName=m.loRam.XFN
      .FontSize=m.loRam.XFS
      .FontBold=m.loRam.XB
      .FontItalic=m.loRam.XI
      .FontUnderline=m.loRam.XU
      .FontStrikethru=m.loRam.XS
      .ForeColor=m.loRam.XC
      .FontCHarset = m.loRam.XFCHS
      *.BorderStyle=1
      *.AutoSize=.T. 
      IF ISNULL(m.loRam.XBGC)
         .BackStyle=0
      ELSE
         .BackColor=m.loRam.XBGC
      ENDIF
      .Visible=.T.
      ENDWITH
      RETURN m.lcName 
   ENDPROC


   PROCEDURE TF_AddPicture(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_AddPicture
      *
      LOCAL m.lcName 
      m.lcName="_"+LTRIM(STR(_Screen.ControlCount,11))+"_img"
      _Screen.AddObject(m.lcName,"image")
      m.loLabel=EVALUATE("_Screen."+m.lcName)
      WITH m.loLabel
      .Picture=m.loRam.XWORD
      .Stretch=m.loRam.XIGS && 0 - Clip, 1 - Isometric, 2 - Stretch
      .Left=m.loRam.NLEFT/10000*96
      .Top=m.loRam.NTOP/10000*96
      .Width=m.loRam.NWIDTH/10000*96
      .Height=m.loRam.NHEIGHTA/10000*96
      .Visible=.T.
      ENDWITH
      RETURN m.lcName 
   ENDPROC
   

   PROCEDURE TF_AddHLine(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_AddHLine
      *
      LOCAL m.lcName 
      m.lcName="_"+LTRIM(STR(_Screen.ControlCount,11))+"_line"
      _Screen.AddObject(m.lcName,"line")
      m.loLabel=EVALUATE("_Screen."+m.lcName)
      WITH m.loLabel
      .Left=m.loRam.NLEFT/10000*96
      .Top=m.loRam.NTOP/10000*96
      .Width=m.loRam.NWIDTH/10000*96
      .Height=0
      .BorderWidth=m.loRam.XBW/10000*96
      .BorderStyle=IIF(m.loRam.XBS=0,0,IIF(m.loRam.XBS=1,3,IIF(m.loRam.XBS=2,2,IIF(m.loRam.XBS=3,4,IIF(m.loRam.XBS=4,5,1)))))
      
      IIF(m.loRam.XBS=1,3,IIF(m.loRam.XBS=2,2,IIF(m.loRam.XBS=3,4,IIF(m.loRam.XBS=4,5,IIF(m.loRam.XBS=8,1,0)))))
      .BorderColor=m.loRam.XBC
      .Visible=.T.
      ENDWITH
      RETURN m.lcName 

*!* 1    (Default) Solid. The outer edge of the border is the outer edge of the Shape control.
*!* 2    Dash
*!* 3    Dot
*!* 4    Dash-Dot
*!* 5    Dash-Dot-Dot
*!* 6    Inside Solid
 
*!* 0 'none' && report
*!* 1 'dotted'
*!* 2 'dashed'
*!* 3 'dash dot'
*!* 4 'das dot dot'
*!* 8 'solid'

   ENDPROC
   

   PROCEDURE TF_AddVLine(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_AddVLine
      *
      LOCAL m.lcName 
      m.lcName="_"+LTRIM(STR(_Screen.ControlCount,11))+"_line"
      _Screen.AddObject(m.lcName,"line")
      m.loLabel=EVALUATE("_Screen."+m.lcName)
      WITH m.loLabel
      .Left=m.loRam.NLEFT/10000*96
      .Top=m.loRam.NTOP/10000*96
      .Width=0
      .Height=m.loRam.NHEIGHTA/10000*96
      .BorderWidth=m.loRam.XBW/10000*96
      .BorderStyle=IIF(m.loRam.XBS=0,0,IIF(m.loRam.XBS=1,3,IIF(m.loRam.XBS=2,2,IIF(m.loRam.XBS=3,4,IIF(m.loRam.XBS=4,5,1)))))
      
      IIF(m.loRam.XBS=1,3,IIF(m.loRam.XBS=2,2,IIF(m.loRam.XBS=3,4,IIF(m.loRam.XBS=4,5,IIF(m.loRam.XBS=8,1,0)))))
      .BorderColor=m.loRam.XBC
      .Visible=.T.
      ENDWITH
      RETURN m.lcName 

*!* 1    (Default) Solid. The outer edge of the border is the outer edge of the Shape control.
*!* 2    Dash
*!* 3    Dot
*!* 4    Dash-Dot
*!* 5    Dash-Dot-Dot
*!* 6    Inside Solid
 
*!* 0 'none' && report
*!* 1 'dotted'
*!* 2 'dashed'
*!* 3 'dash dot'
*!* 4 'das dot dot'
*!* 8 'solid'

   ENDPROC
   
   PROCEDURE TF_AddRectangle(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_AddRectangle
      *
      LOCAL m.lcName 
      m.lcName=SYS(2015)
      _Screen.AddObject(m.lcName,"shape")
      m.loLabel=EVALUATE("_Screen."+m.lcName)
      WITH m.loLabel
      .Left=m.loRam.NLEFT/10000*96
      .Top=m.loRam.NTOP/10000*96
      .Width=m.loRam.NWIDTH/10000*96
      .Height=m.loRam.NHEIGHTA/10000*96
      .BorderWidth=m.loRam.XBW/10000*96
      .BorderStyle=IIF(m.loRam.XBS=1,3,IIF(m.loRam.XBS=2,2,IIF(m.loRam.XBS=3,4,IIF(m.loRam.XBS=4,5,IIF(m.loRam.XBS=8,1,0)))))
      .BorderColor=m.loRam.XBC
      .Curvature=m.loRam.XBR
      IF ISNULL(m.loRam.XBGC)
         .BackStyle=0
      ELSE
         .BackColor=m.loRam.XBGC
      ENDIF
      .Visible=.T.
      ENDWITH
      RETURN m.lcName 
   ENDPROC


   PROCEDURE TF_NewParagraph(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_NewParagraph
      *
   ENDPROC


   PROCEDURE TF_EndParagraph(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_EndParagraph
      *
   ENDPROC


   PROCEDURE TF_NewLine(m.loRam, m.liParentObject)
      *
      * _SCREENHOST::TF_NewLine
      *
   ENDPROC
   
ENDDEF

